## mingw-w64-itk-5.4.4-2.src.tar.zst

=== Documentation/docs/requirements.txt ===
furo
myst-parser[linkify]
sphinx>=7.2.6
sphinx-copybutton
sphinx-design
sphinxext-opengraph

=== Modules/Compatibility/Deprecated/CMakeLists.txt ===
project(ITKDeprecated)
set(ITKDeprecated_LIBRARIES ITKDeprecated)
itk_module_impl()

=== Modules/IO/MeshBYU/CMakeLists.txt ===
project(ITKIOMeshBYU)
set(ITKIOMeshBYU_LIBRARIES ITKIOMeshBYU)
itk_module_impl()

=== Modules/IO/MeshBase/CMakeLists.txt ===
project(ITKIOMeshBase)

set(ITKIOMeshBase_LIBRARIES ITKIOMeshBase)
itk_module_impl()

=== Modules/Registration/Metricsv4/CMakeLists.txt ===
project(ITKMetricsv4)
itk_module_impl()

=== Modules/ThirdParty/DCMTK/CMakeLists.txt ===
project(ITKDCMTK)

set(ITKDCMTK_THIRD_PARTY 1)

# This depends on the external project, nothing locally built
set(ITKDCMTK_NO_SRC 1)

include(CMakeParseArguments)


if(DCMTK_USE_ICU)
  option(ITK_USE_SYSTEM_ICU "Use an installed version of ICU" OFF)
  if(NOT ITK_USE_SYSTEM_ICU)
    set(ITKDCMTK_PREREQS ${ITKDCMTK_BINARY_DIR}/DCMTK_Prereqs)
    set(ITKDCMTK_ICU_LIBRARIES )
    if(WIN32)
      message(FATAL_ERROR "ICU is not built as part of ITK on Windows. Please compile it outside of ITK.")
    else()
      set(ITKDCMTK_ICU_LIBRARY_NAMES uc data)
    endif()
    foreach(lib_name ${ITKDCMTK_ICU_LIBRARY_NAMES})
      set(lib ICU::${lib_name})
      list(APPEND ITKDCMTK_ICU_LIBRARIES ${lib})
      add_library(${lib} STATIC IMPORTED GLOBAL)
      if(CMAKE_CONFIGURATION_TYPES)
        foreach(c ${CMAKE_CONFIGURATION_TYPES})
          string(TOUPPER "${c}" C)
          set(debug_suffix)
          if("${C}" STREQUAL "DEBUG")
            set(lib_path ${ITKDCMTK_PREREQS}/${c}/lib/${lib_prefix}icu${lib_name}d${CMAKE_STATIC_LIBRARY_SUFFIX})
          else()  # For all non-debug, use release
            set(lib_path ${ITKDCMTK_PREREQS}/Release/lib/${lib_prefix}icu${lib_name}${CMAKE_STATIC_LIBRARY_SUFFIX})
          endif()
          set_property(TARGET ${lib} PROPERTY IMPORTED_LOCATION_${C} ${lib_path})
        endforeach()
      else()
        set(lib_path ${ITKDCMTK_PREREQS}/lib/${lib_prefix}icu${lib_name}${CMAKE_STATIC_LIBRARY_SUFFIX})
        set_property(TARGET ${lib} PROPERTY IMPORTED_LOCATION ${lib_path})
      endif()
      list(APPEND ICU_BYPRODUCTS "${lib_path}")
    endforeach()

    set(ICU_URL "http://download.icu-project.org/files/icu4c/58.2/icu4c-58_2-src.tgz")
    set(ICU_MD5 fac212b32b7ec7ab007a12dff1f3aea1)
    # If not Debug, use Release (for Release, MinSizeRel,...)
    if(CMAKE_CONFIGURATION_TYPES)
      set(ICU_ROOT_DIR ${ITKDCMTK_PREREQS}/$<$<CONFIG:Debug>:Debug>$<$<NOT:$<CONFIG:Debug>>:Release>)
    else()
      set(ICU_ROOT_DIR ${ITKDCMTK_PREREQS})
    endif()
    set(CHARSET_CONVERSION_ARGS
      -DDCMTK_WITH_STDLIBC_ICONV:BOOL=OFF
      -DDCMTK_WITH_ICU:BOOL=ON
      -DDCMTK_ENABLE_CHARSET_CONVERSION:STRING=ICU
      -DICU_ROOT:PATH=${ICU_ROOT_DIR}
      )
    itk_download_attempt_check(icu)
    ExternalProject_Add(icu
    URL ${ICU_URL}
    URL_MD5 ${ICU_MD5}
    PREFIX ${ITKDCMTK_BINARY_DIR}
    UPDATE_COMMAND ""
    BUILD_BYPRODUCTS ${ICU_BYPRODUCTS}
    CONFIGURE_COMMAND <SOURCE_DIR>/source/configure --prefix=${ITKDCMTK_PREREQS}
      --with-data-packaging=static
      --enable-static=yes
      --enable-shared=no
      "CC=${CMAKE_C_COMPILER_LAUNCHER} ${CMAKE_C_COMPILER}"
      "CXX=${CMAKE_CXX_COMPILER_LAUNCHER} ${CMAKE_CXX_COMPILER}"
      "CFLAGS=-fPIC"
      "CXXFLAGS=-fPIC"
    )
    set(ICU_DEPENDENCY icu)
  endif()
else(DCMTK_USE_ICU)
  set(CHARSET_CONVERSION_ARGS
     -DDCMTK_WITH_ICU:BOOL=OFF
     )
endif()

set(_ITKDCMTK_LIB_NAMES dcmdata dcmimage dcmimgle dcmjpeg dcmjpls
    dcmnet dcmpstat dcmqrdb dcmsr dcmtls ijg12 ijg16 ijg8 oflog ofstd oficonv)
if(WIN32)
  set(ITKDCMTK_LIBDEP_WIN iphlpapi ws2_32 netapi32 wsock32)
endif()

#
# if DCMTK is built elsewhere
if(ITK_USE_SYSTEM_DCMTK)
  # assign includes to std module var
  set(ITKDCMTK_SYSTEM_INCLUDE_DIRS ${DCMTK_INCLUDE_DIRS})

  # Module standard library var
  set(ITKDCMTK_LIBRARIES ${DCMTK_LIBRARIES})

  # When this module is loaded by an app, load DCMTK too.
  set(ITKDCMTK_EXPORT_CODE_INSTALL "
set(DCMTK_DIR \"${DCMTK_DIR}\")
find_package(DCMTK REQUIRED NO_MODULE)
")
  set(ITKDCMTK_EXPORT_CODE_BUILD "
if(NOT ITK_BINARY_DIR)
  set(CMAKE_MODULE_PATH
    \"${CMAKE_CURRENT_SOURCE_DIR}/CMake\" \${CMAKE_MODULE_PATH})
  set(DCMTK_DIR \"${DCMTK_DIR}\")
  find_package(DCMTK REQUIRED NO_MODULE)
endif()
")

  itk_module_impl()

else(ITK_USE_SYSTEM_DCMTK)
  set(DCMTK_EPNAME ITKDCMTK_ExtProject)
  set(lib_dir ${CMAKE_CURRENT_BINARY_DIR}/${DCMTK_EPNAME}-build/lib)

  if(BUILD_SHARED_LIBS)
    set(_ITKDCMTK_LIB_LINKAGE SHARED)
  else()
    set(_ITKDCMTK_LIB_LINKAGE STATIC)
  endif()
  foreach(lib ${_ITKDCMTK_LIB_NAMES})
    # add it as an imported  library target
    add_library(${lib} ${_ITKDCMTK_LIB_LINKAGE} IMPORTED GLOBAL)
  endforeach()

  # Use DCMTK include files in place in the build directory.
  set(ITKDCMTK_INCLUDE ${CMAKE_CURRENT_BINARY_DIR}/${DCMTK_EPNAME})

  # 'stringize' the libraries. Brad King addition
  set(ITKDCMTK_LIBRARIES "${_ITKDCMTK_LIB_NAMES}")
  #
  # add all the embedded include directories to include dirs
  foreach(lib ${_ITKDCMTK_LIB_NAMES})
    # add to include list
    list(APPEND ITKDCMTK_INCLUDE_DIRS
      ${ITKDCMTK_INCLUDE}/${lib}/include)
  endforeach()

  #
  # need the base include dir as well.
  list(APPEND ITKDCMTK_INCLUDE_DIRS
    ${CMAKE_CURRENT_BINARY_DIR}/${DCMTK_EPNAME}-build/config/include)

  set(ITKDCMTK_EXPORT_CODE_BUILD "
set(CMAKE_MODULE_PATH
  \"${CMAKE_CURRENT_SOURCE_DIR}/CMake\" \${CMAKE_MODULE_PATH})
")

set(ITKDCMTK_LINK_DEPENDENCIES ${ITKDCMTK_LIBDEP_WIN})
  # create imported targets when module is loaded from build tree
  if(CMAKE_CONFIGURATION_TYPES)
    set(ITKDCMTK_EXPORT_CODE_BUILD "
${ITKDCMTK_EXPORT_CODE_BUILD}
foreach(lib ${_ITKDCMTK_LIB_NAMES})
  if(NOT TARGET \${lib})
    add_library(\${lib} ${_ITKDCMTK_LIB_LINKAGE} IMPORTED)
    foreach(c ${CMAKE_CONFIGURATION_TYPES})
      string(TOUPPER \"\${c}\" C)
      set_property(TARGET \${lib} PROPERTY IMPORTED_LOCATION_\${C}
        \"${lib_dir}/\${c}/${lib_prefix}\${lib}${lib_suffix}\")
    set_property(TARGET \${lib} PROPERTY
      IMPORTED_LINK_INTERFACE_LIBRARIES
      ${ITKDCMTK_LINK_DEPENDENCIES})
    endforeach()
  endif()
endforeach()
")
  else()
    set(ITKDCMTK_EXPORT_CODE_BUILD "
${ITKDCMTK_EXPORT_CODE_BUILD}
foreach(lib ${_ITKDCMTK_LIB_NAMES})
  if(NOT TARGET \${lib})
    add_library(\${lib} ${_ITKDCMTK_LIB_LINKAGE} IMPORTED)
    set_property(TARGET \${lib} PROPERTY IMPORTED_LOCATION
      \"${lib_dir}/${lib_prefix}\${lib}${lib_suffix}\")
    set_property(TARGET \${lib} PROPERTY
      IMPORTED_LINK_INTERFACE_LIBRARIES
      ${ITKDCMTK_LINK_DEPENDENCIES})
  endif()
endforeach()
")
  endif()
  # create imported targets when module is loaded from install tree
  set(ITKDCMTK_EXPORT_CODE_INSTALL "
foreach(lib ${_ITKDCMTK_LIB_NAMES})
  if(NOT TARGET \${lib})
    add_library(\${lib} ${_ITKDCMTK_LIB_LINKAGE} IMPORTED)
    set_property(TARGET \${lib} PROPERTY IMPORTED_LOCATION
            \"\${ITK_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/${lib_prefix}\${lib}${lib_suffix}\")
    set_property(TARGET \${lib} PROPERTY
      IMPORTED_LINK_INTERFACE_LIBRARIES
      ${ITKDCMTK_LINK_DEPENDENCIES})
  endif()
endforeach()
")

  # implement module before the ExternalProject, to process
  # dependencies
  itk_module_impl()

  foreach(libdep JPEG TIFF ZLIB PNG)
    #
    # if we're using ITK-built versions of libraries, then
    # have to find the actual library name, instead of the cmake logical name
    set(DCMTK${libdep}_LIBRARIES "")

    foreach(_lib ${ITK${libdep}_LIBRARIES})
      if(TARGET ${_lib})
        set(_lib $<TARGET_FILE:${_lib}>)
      endif()
      list(APPEND DCMTK${libdep}_LIBRARIES ${_lib})
    endforeach()

    # have to replace ; with another separator in order to pass lists into
    # the external project without them getting messed up.
    string(REPLACE ";" ":::" DCMTK${libdep}_LIBRARIES "${DCMTK${libdep}_LIBRARIES}")
    string(REPLACE ";" ":::" DCMTK${libdep}_INCLUDE_DIRS "${ITK${libdep}_INCLUDE_DIRS}")
  endforeach()

  include(${CMAKE_CURRENT_LIST_DIR}/DCMTKGitTag.cmake)

  set(DCMTK_EP_FLAGS
    -DCMAKE_CXX_STANDARD:STRING=${CMAKE_CXX_STANDARD}
    -DCMAKE_CXX_STANDARD_REQUIRED:BOOL=${CMAKE_CXX_STANDARD_REQUIRED}
    -DCMAKE_CXX_EXTENSIONS:BOOL=${CMAKE_CXX_EXTENSIONS}
    -DDCMTK_ENABLE_CXX11:BOOL=ON
    -DDCMTK_FORCE_FPIC_ON_UNIX:BOOL=ON
    -DBUILD_APPS:BOOL=OFF        # Only DCMTK libraries are needed
    -DDCMTK_WITH_OPENSSL:BOOL=OFF
    -DDCMTK_WITH_PNG:BOOL=ON
    -DDCMTK_WITH_XML:BOOL=OFF
    -DDCMTK_WITH_TIFF:BOOL=ON
    -DDCMTK_WITH_ZLIB:BOOL=ON)

  if(MSVC)
    list(APPEND DCMTK_EP_FLAGS -DDCMTK_OVERWRITE_WIN32_COMPILER_FLAGS:BOOL=OFF)
  endif()

  if("${CMAKE_GENERATOR}" MATCHES "Unix Makefiles")
    list(APPEND DCMTK_EP_FLAGS -DCMAKE_VERBOSE_MAKEFILE:BOOL=${CMAKE_VERBOSE_MAKEFILE})
  endif()


  # build the list of libraries upon which DCMTK depends
  set(ITKDCMTK_LIBDEP "")
  list(APPEND ITKDCMTK_LIBDEP ${ITKDCMTK_LIBDEP_WIN})
  foreach(lib ITKJPEG_LIBRARIES ITKTIFF_LIBRARIES ITKPNG_LIBRARIES
      ITKZLIB_LIBRARIES ITKDCMTK_ICU_LIBRARIES)
    foreach(_lib ${${lib}})
      if(TARGET ${_lib})
        list(APPEND ITKDCMTK_LIBDEP ${_lib})
      endif()
    endforeach()
  endforeach()
  # attach actual filenames to the
  # imported libraries from the ExternalProject
  foreach(lib ${_ITKDCMTK_LIB_NAMES})
    # tell the imported library where it's file lives
    if(CMAKE_CONFIGURATION_TYPES)
      foreach(c ${CMAKE_CONFIGURATION_TYPES})
        string(TOUPPER "${c}" C)
        set_property(TARGET ${lib} PROPERTY IMPORTED_LOCATION_${C}
          ${lib_dir}/${c}/${lib_prefix}${lib}${lib_suffix})
        list(APPEND DCMTK_BYPRODUCTS "${lib_dir}/${c}/${lib_prefix}${lib}${lib_suffix}")
      endforeach()
    else()
      set_property(TARGET ${lib} PROPERTY IMPORTED_LOCATION
        ${lib_dir}/${lib_prefix}${lib}${lib_suffix})
      list(APPEND DCMTK_BYPRODUCTS "${lib_dir}/${lib_prefix}${lib}${lib_suffix}")
    endif()

    # make the imported library depend on its prerequisite
    # libraries
    set_property(TARGET ${lib} PROPERTY
      IMPORTED_LINK_INTERFACE_LIBRARIES
      ${ITKDCMTK_LIBDEP} )
  endforeach()

  if(CMAKE_VERSION VERSION_LESS 3.4)
    set(CMAKE_CXX_COMPILER_LAUNCHER_FLAG )
    set(CMAKE_C_COMPILER_LAUNCHER_FLAG )
  else()
    set(CMAKE_CXX_COMPILER_LAUNCHER_FLAG -DCMAKE_CXX_COMPILER_LAUNCHER:FILEPATH=${CMAKE_CXX_COMPILER_LAUNCHER})
    set(CMAKE_C_COMPILER_LAUNCHER_FLAG -DCMAKE_C_COMPILER_LAUNCHER:FILEPATH=${CMAKE_C_COMPILER_LAUNCHER})
  endif()
  set(_cross_compiling_flags)
  if(CMAKE_TOOLCHAIN_FILE)
    list(APPEND _cross_compiling_flags -DCMAKE_TOOLCHAIN_FILE:FILEPATH=${CMAKE_TOOLCHAIN_FILE})
  endif()
  if(CMAKE_CROSSCOMPILING_EMULATOR)
    list(APPEND _cross_compiling_flags -DCMAKE_CROSSCOMPILING_EMULATOR:FILEPATH=${CMAKE_CROSSCOMPILING_EMULATOR})
  endif()
  itk_download_attempt_check(${DCMTK_EPNAME})
  ExternalProject_Add(${DCMTK_EPNAME}
    GIT_REPOSITORY ${DCMTK_GIT_REPOSITORY}
    GIT_TAG ${DCMTK_GIT_TAG}
    SOURCE_DIR ${DCMTK_EPNAME}
    BINARY_DIR ${DCMTK_EPNAME}-build
    LIST_SEPARATOR ":::"
    INSTALL_COMMAND ""
   CMAKE_ARGS
    -DCMAKE_BUILD_TYPE:STRING=${CMAKE_BUILD_TYPE}
    -DBUILD_SHARED_LIBS:BOOL=${BUILD_SHARED_LIBS}
    -DCMAKE_MSVC_RUNTIME_LIBRARY:STRING=${CMAKE_MSVC_RUNTIME_LIBRARY}
    -DDCMTK_DEFAULT_DICT:STRING=builtin
    -DDCMTK_WITH_DOXYGEN:BOOL=OFF
    -DDCMTK_WITH_SNDFILE:BOOL=OFF
    -DDCMTK_WITH_WRAP:BOOL=OFF
    -DDCMTK_ENABLE_PRIVATE_TAGS:BOOL=ON
    -DJPEG_LIBRARY:PATH=${DCMTKJPEG_LIBRARIES}
    -DJPEG_INCLUDE_DIR:PATH=${DCMTKJPEG_INCLUDE_DIRS}
    -DTIFF_INCLUDE_DIR:STRING=${DCMTKTIFF_INCLUDE_DIRS}
    -DTIFF_LIBRARY:PATH=${DCMTKTIFF_LIBRARIES}
    -DZLIB_INCLUDE_DIRS:STRING=${DCMTKZLIB_INCLUDE_DIRS}
    -DZLIB_LIBS:PATH=${DCMTKZLIB_LIBRARIES}
    -DPNG_INCLUDE_DIR:STRING=${DCMTKPNG_INCLUDE_DIRS}
    -DPNG_LIBRARY:PATH=${DCMTKPNG_LIBRARIES}
    ${DCMTK_EP_FLAGS}
    ${_cross_compiling_flags}
    -DCMAKE_CXX_COMPILER:FILEPATH=${CMAKE_CXX_COMPILER}
    ${CMAKE_CXX_COMPILER_LAUNCHER_FLAG}
    -DCMAKE_C_COMPILER:FILEPATH=${CMAKE_C_COMPILER}
    ${CMAKE_C_COMPILER_LAUNCHER_FLAG}
    -DCMAKE_LIBRARY_OUTPUT_DIRECTORY:PATH=${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
    -DCMAKE_ARCHIVE_OUTPUT_DIRECTORY:PATH=${CMAKE_ARCHIVE_OUTPUT_DIRECTORY}
    -DCMAKE_RUNTIME_OUTPUT_DIRECTORY:PATH=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
    -DCMAKE_INSTALL_PREFIX:PATH=${CMAKE_INSTALL_PREFIX}
    -DCMAKE_INSTALL_LIBDIR:PATH=${CMAKE_INSTALL_LIBDIR}
    -DCMAKE_INSTALL_BINDIR:PATH=${CMAKE_INSTALL_BINDIR}

=== Modules/Core/Mesh/wrapping/CMakeLists.txt ===
itk_wrap_module(ITKMesh)

set(WRAPPER_SUBMODULE_ORDER
    itkMeshBase
    itkMeshSource
    itkImageToMeshFilter
    itkMeshToMeshFilter
    itkVTKPolyDataReader
    itkVTKPolyDataWriter)
itk_auto_load_and_end_wrap_submodules()

=== Modules/IO/GE/test/CMakeLists.txt ===
itk_module_test()
set(ITKIOGETests itkGEImageIOTest.cxx)

createtestdriver(ITKIOGE "${ITKIOGE-Test_LIBRARIES}" "${ITKIOGETests}")

itk_add_test(
  NAME
  itkGE4
  COMMAND
  ITKIOGETestDriver
  --compareCoordinateTolerance
  1e-5 # Fails on Windows otherwise
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/IO/19771.002.001.mha}
  ${ITK_TEST_OUTPUT_DIR}/19771.002.001.mha
  itkGEImageIOTest
  ${ITK_TEST_OUTPUT_DIR}
  true
  GE4
  DATA{${ITK_DATA_ROOT}/Input/test_ge4/19771.002.001,REGEX:19771\\.002\\.00[1-6]}
  ${ITK_TEST_OUTPUT_DIR}/19771.002.001.mha)
itk_add_test(
  NAME
  itkGE5
  COMMAND
  ITKIOGETestDriver
  --compareCoordinateTolerance
  1e-5 # Fails on Windows otherwise
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/IO/113766.003.001.mha}
  ${ITK_TEST_OUTPUT_DIR}/113766.003.001.mha
  itkGEImageIOTest
  ${ITK_TEST_OUTPUT_DIR}
  true
  GE5
  DATA{${ITK_DATA_ROOT}/Input/test_ge5/113766.003.001,REGEX:113766\\.003\\.00[1-6]}
  ${ITK_TEST_OUTPUT_DIR}/113766.003.001.mha)
itk_add_test(
  NAME
  itkGE5Test2
  COMMAND
  ITKIOGETestDriver
  --compare
  DATA{Baseline/c_vf1122.fre.mha}
  ${ITK_TEST_OUTPUT_DIR}/c_vf1122.fre.mha
  itkGEImageIOTest
  ${ITK_TEST_OUTPUT_DIR}
  true
  GE5
  DATA{Input/c_vf1122.fre}
  ${ITK_TEST_OUTPUT_DIR}/c_vf1122.fre.mha)
itk_add_test(
  NAME
  itkGE5Test3
  COMMAND
  ITKIOGETestDriver
  --compare
  DATA{Baseline/c_vf1122.fre.mha}
  ${ITK_TEST_OUTPUT_DIR}/c_vf1123.fre.mha
  itkGEImageIOTest
  ${ITK_TEST_OUTPUT_DIR}
  true
  GE5
  DATA{Input/c_vf1123.fre}
  ${ITK_TEST_OUTPUT_DIR}/c_vf1123.fre.mha)
itk_add_test(
  NAME
  itkGE5Test4
  COMMAND
  ITKIOGETestDriver
  --compare
  DATA{Baseline/c_vf1210.fre.mha}
  ${ITK_TEST_OUTPUT_DIR}/c_vf1210.fre.mha
  itkGEImageIOTest
  ${ITK_TEST_OUTPUT_DIR}
  true
  GE5
  DATA{Input/c_vf1210.fre}
  ${ITK_TEST_OUTPUT_DIR}/c_vf1210.fre.mha)
itk_add_test(
  NAME
  itkGE5Test5
  COMMAND
  ITKIOGETestDriver
  --compare
  DATA{Baseline/c_vf1210.fre.mha}
  ${ITK_TEST_OUTPUT_DIR}/c_vf1211.fre.mha
  itkGEImageIOTest
  ${ITK_TEST_OUTPUT_DIR}
  true
  GE5
  DATA{Input/c_vf1211.fre}
  ${ITK_TEST_OUTPUT_DIR}/c_vf1211.fre.mha)
itk_add_test(
  NAME
  itkGEAdw
  COMMAND
  ITKIOGETestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/IO/I.001.mha}
  ${ITK_TEST_OUTPUT_DIR}/I.001.mha
  itkGEImageIOTest
  ${ITK_TEST_OUTPUT_DIR}
  true
  GEAdw
  DATA{${ITK_DATA_ROOT}/Input/test_geadw/I.001,REGEX:I\\.00[1-6]}
  ${ITK_TEST_OUTPUT_DIR}/I.001.mha)
itk_add_test(
  NAME
  itkSiemens
  COMMAND
  ITKIOGETestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/IO/3868-2-100.mha}
  ${ITK_TEST_OUTPUT_DIR}/3868-2-100.mha
  itkGEImageIOTest
  ${ITK_TEST_OUTPUT_DIR}
  true
  Siemens
  DATA{${ITK_DATA_ROOT}/Input/test_siemens/3868-2-100.ima,REGEX:3868-2-10[0-5]\\.ima}
  ${ITK_TEST_OUTPUT_DIR}/3868-2-100.mha)
itk_add_test(
  NAME
  itkGE4Fail
  COMMAND
  ITKIOGETestDriver
  itkGEImageIOTest
  ${ITK_TEST_OUTPUT_DIR}
  false
  GE4
  DATA{${ITK_DATA_ROOT}/Input/test_ge5/113766.003.001,REGEX:113766\\.003\\.00[1-6]})
itk_add_test(
  NAME
  itkGE5Fail
  COMMAND
  ITKIOGETestDriver
  itkGEImageIOTest
  ${ITK_TEST_OUTPUT_DIR}
  false
  GE5
  DATA{${ITK_DATA_ROOT}/Input/test_ge4/19771.002.001,REGEX:19771\\.002\\.00[1-6]})
itk_add_test(
  NAME
  itkGEAdwFail
  COMMAND
  ITKIOGETestDriver
  itkGEImageIOTest
  ${ITK_TEST_OUTPUT_DIR}
  false
  GEAdw
  DATA{${ITK_DATA_ROOT}/Input/test_siemens/3868-2-100.ima,REGEX:3868-2-10[0-5]\\.ima})
itk_add_test(
  NAME
  itkSiemensFail
  COMMAND
  ITKIOGETestDriver
  itkGEImageIOTest
  ${ITK_TEST_OUTPUT_DIR}
  false
  Siemens
  DATA{${ITK_DATA_ROOT}/Input/test_geadw/I.001,,REGEX:I\\.00[1-6]})

=== Modules/IO/GE/wrapping/CMakeLists.txt ===
itk_wrap_module(ITKIOGE)
itk_auto_load_and_end_wrap_submodules()

=== Modules/IO/MeshOBJ/wrapping/CMakeLists.txt ===
itk_wrap_module(ITKIOMeshOBJ)
itk_auto_load_and_end_wrap_submodules()

=== Modules/IO/NIFTI/test/CMakeLists.txt ===
itk_module_test()
set(ITKIONIFTITests
    itkNiftiImageIOTest.cxx
    itkNiftiImageIOTest2.cxx
    itkNiftiImageIOTest3.cxx
    itkNiftiImageIOTest4.cxx
    itkNiftiImageIOTest5.cxx
    itkNiftiImageIOTest6.cxx
    itkNiftiImageIOTest7.cxx
    itkNiftiImageIOTest8.cxx
    itkNiftiImageIOTest9.cxx
    itkNiftiImageIOTest10.cxx
    itkNiftiImageIOTest11.cxx
    itkNiftiImageIOTest12.cxx
    itkNiftiImageIOTest13.cxx
    itkNiftiImageIOTest14.cxx
    itkNiftiLargeImageRegionReadTest.cxx
    itkNiftiReadAnalyzeTest.cxx
    itkNiftiReadWriteDirectionTest.cxx
    itkExtractSlice.cxx
    itkNiftiWriteCoerceOrthogonalDirectionTest.cxx)

# For itkNiftiImageIOTest.h.
include_directories(${ITKIONIFTI_SOURCE_DIR}/test)

add_library(ITKIONIFTI-TestSupport itkNiftiImageIOTestHelper.cxx)
itk_module_target_label(ITKIONIFTI-TestSupport)
target_link_libraries(ITKIONIFTI-TestSupport LINK_PUBLIC ${ITKIONIFTI-Test_LIBRARIES})

list(APPEND ITKIONIFTI-Test_LIBRARIES ITKIONIFTI-TestSupport)

createtestdriver(ITKIONIFTI "${ITKIONIFTI-Test_LIBRARIES}" "${ITKIONIFTITests}")

itk_add_test(
  NAME
  itkNiftisform2DirectionDef.nii.gz
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiImageIOTest
  ${ITK_TEST_OUTPUT_DIR}/itkNiftisform2DirectionDefNiiGzTest.nii.gz
  DATA{${ITK_DATA_ROOT}/Input/itkNiftisform2DirectionDef.nii.gz})

itk_add_test(
  NAME
  itkNiftiIOBigEndianCompressed.hdr
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiImageIOTest
  ${ITK_TEST_OUTPUT_DIR}/itkNiftiIOBigEndianCompressedHdrTest.nii.gz
  itkNiftiIOBigEndianCompressed.hdr
  DATA{${ITK_DATA_ROOT}/Input/BigEndianCompressed.hdr})
itk_add_test(
  NAME
  itkNiftiIOBigEndianCompressed.img
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiImageIOTest
  ${ITK_TEST_OUTPUT_DIR}/itkNiftiIOBigEndianCompressedImgTest.nii.gz
  itkNiftiIOBigEndianCompressed.img
  DATA{${ITK_DATA_ROOT}/Input/BigEndianCompressed.img})
itk_add_test(
  NAME
  itkNiftiIOBigEndianCompressed.img.gz
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiImageIOTest
  ${ITK_TEST_OUTPUT_DIR}/itkNiftiIOBigEndianCompressedImgGz.nii.gz
  itkNiftiIOBigEndianCompressed.img.gz
  DATA{${ITK_DATA_ROOT}/Input/BigEndianCompressed.img.gz})
itk_add_test(
  NAME
  itkNiftiIOBigEndian
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiImageIOTest
  ${ITK_TEST_OUTPUT_DIR}/itkNiftiIOBigEndianTest.nii.gz
  itkNiftiIOBigEndian
  DATA{${ITK_DATA_ROOT}/Input/BigEndian.hdr,BigEndian.mhd,BigEndian.img})
itk_add_test(
  NAME
  itkNiftiIOLittleEndianCompressed
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiImageIOTest
  ${ITK_TEST_OUTPUT_DIR}/itkNiftiIOLittleEndianCompressedTest.nii.gz
  itkNiftiImageIOTest
  DATA{${ITK_DATA_ROOT}/Input/LittleEndianCompressed.hdr,LittleEndianCompressed.img.gz})
itk_add_test(
  NAME
  itkNiftiIOLittleEndian
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiImageIOTest
  ${ITK_TEST_OUTPUT_DIR}/itkNiftiIOLittleEndianCompressedTest.nii.gz
  itkNiftiIOLittleEndian
  DATA{${ITK_DATA_ROOT}/Input/LittleEndian.hdr,LittleEndian.mhd,LittleEndian.img})
itk_add_test(
  NAME
  itkNiftiIOInternalTests
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiImageIOTest
  ${ITK_TEST_OUTPUT_DIR}/itkNiftiIOInternalTestsTest.nii.gz)
itk_add_test(
  NAME
  itkNiftiIOShouldFail
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiImageIOTest2
  ${ITK_TEST_OUTPUT_DIR}
  itkNiftiIOShouldFail
  false
  DATA{${ITK_DATA_ROOT}/Input/ramp.gipl})
itk_add_test(
  NAME
  itkNiftiIOShouldSucceed
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiImageIOTest2
  ${ITK_TEST_OUTPUT_DIR}
  itkNiftiIOShouldSucceed
  true
  DATA{${ITK_DATA_ROOT}/Input/LittleEndian.hdr,LittleEndian.mhd,LittleEndian.img})
itk_add_test(
  NAME
  itkDirCosinesTest
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiImageIOTest4
  ${ITK_TEST_OUTPUT_DIR})
itk_add_test(
  NAME
  itkNiftiSlopeInterceptTest
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiImageIOTest5
  ${ITK_TEST_OUTPUT_DIR})
itk_add_test(
  NAME
  itkNiftiVectorImageTest2
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiImageIOTest6
  ${ITK_TEST_OUTPUT_DIR})
itk_add_test(
  NAME
  itkNiftiDiffusionTensor3dImageTest
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiImageIOTest7
  ${ITK_TEST_OUTPUT_DIR})
itk_add_test(
  NAME
  itkNiftiSymmetricSecondRankTensorImageTest
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiImageIOTest8
  ${ITK_TEST_OUTPUT_DIR})
itk_add_test(
  NAME
  itkNiftiRGBImageTest
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiImageIOTest9
  ${ITK_TEST_OUTPUT_DIR}
  RGBImage.nii.gz)
itk_add_test(
  NAME
  itkNiftiRGBAImageTest
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiImageIOTest10
  ${ITK_TEST_OUTPUT_DIR}
  RGBAImage.nii.gz)
itk_add_test(
  NAME
  itkNiftiVectorImageTest
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiImageIOTest3
  ${ITK_TEST_OUTPUT_DIR})
itk_add_test(
  NAME
  itkNiftiDimensionLimitsTest
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiImageIOTest11
  ${ITK_TEST_OUTPUT_DIR}
  SizeFailure.nii.gz)
itk_add_test(
  NAME
  itkNiftiLargeRGBTest
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiImageIOTest12
  ${ITK_TEST_OUTPUT_DIR}
  LargeRGBImage.nii.gz)
itk_add_test(
  NAME
  itkNiftiReadAnalyzeTest
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiReadAnalyzeTest
  ${ITK_TEST_OUTPUT_DIR})
itk_add_test(
  NAME
  itkExtractSliceSlopeInterceptUCHAR
  COMMAND
  ITKIONIFTITestDriver
  --compare
  DATA{Baseline/SlopeInterceptUCHAR-midSlice.nrrd}
  ${ITK_TEST_OUTPUT_DIR}/SlopeInterceptUCHAR-midSlice.nrrd
  itkExtractSlice
  DATA{Input/SlopeInterceptUCHAR.nii.gz}
  ${ITK_TEST_OUTPUT_DIR}/SlopeInterceptUCHAR-midSlice.nrrd)

itk_add_test(
  NAME
  itkNiftiReadWriteDirectionTest
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiReadWriteDirectionTest
  DATA{${ITK_DATA_ROOT}/Input/LPSLabels.nii.gz}
  DATA{${ITK_DATA_ROOT}/Input/LPSLabels_noqform.nii.gz}
  DATA{${ITK_DATA_ROOT}/Input/LPSLabels_nosform.nii.gz}
  DATA{${ITK_DATA_ROOT}/Input/NonOrthoSform.nii.gz}
  ${ITK_TEST_OUTPUT_DIR})

itk_add_test(
  NAME
  itkNiftiReadWriteDirectionSmallVoxelTest
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiReadWriteDirectionTest
  DATA{Input/SmallVoxels.nii.gz}
  DATA{Input/SmallVoxels_noqform.nii.gz}
  DATA{Input/SmallVoxels_nosform.nii.gz}
  DATA{Input/SmallVoxelsNonOrthoSform.nii.gz}
  ${ITK_TEST_OUTPUT_DIR})

itk_add_test(
  NAME
  itkNiftiSmallVoxelsAffinePrecisionTest
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiImageIOTest13
  DATA{Input/SmallVoxels_AffinePrecision.nii.gz})

itk_add_test(
  NAME
  itkNiftiSpatialTemporalUnitsTest
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiImageIOTest14
  ${ITK_TEST_OUTPUT_DIR}/xyzt_units_output_check.nii
  DATA{Input/xyzt_units_test_scl_mm_s.nii.gz}
  DATA{Input/xyzt_units_test_scl.nii.gz}
  )

itk_add_test(
  NAME
  itkNiftiSpatialTemporalUnitsTest2
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiImageIOTest14
  ${ITK_TEST_OUTPUT_DIR}/xyzt_units_output_check2.nii
  DATA{Input/xyzt_units_test_scl_mm_s.nii.gz}
  DATA{Input/xyzt_units_test_scl_mm_s.nii.gz}
  )

itk_add_test(
  NAME
  itkNiftiQFormSFormDifferentSpacingTest
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiImageIOTest13
  DATA{Input/ChickenEgg-zeros.nii.gz})

itk_add_test(
  NAME
  itkNiftiLargeImageRegionReadTest
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiLargeImageRegionReadTest
  ${ITK_TEST_OUTPUT_DIR}/itkNiftiLargeImageRegionReadTest.nii.gz)

itk_add_test(
  NAME
  itkNiftiWriteCoerceOrthogonalDirectionTest
  COMMAND
  ITKIONIFTITestDriver
  itkNiftiWriteCoerceOrthogonalDirectionTest
  ${ITK_TEST_OUTPUT_DIR})

=== Modules/IO/Stimulate/wrapping/CMakeLists.txt ===
itk_wrap_module(ITKIOStimulate)
itk_auto_load_and_end_wrap_submodules()

=== PKGBUILD ===
# Maintainer: Sergey Popov <popov.sa@gmail.com>

_realname=itk
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=5.4.4
pkgrel=2
pkgdesc='An open-source C++ toolkit for medical image processing (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.itk.org/'
msys2_repository_url="https://github.com/InsightSoftwareConsortium/ITK"
msys2_references=(
  'aur: itk'
)
license=('spdx:Apache-2.0')
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-dcmtk"
         "${MINGW_PACKAGE_PREFIX}-double-conversion"
         "${MINGW_PACKAGE_PREFIX}-expat"
         "${MINGW_PACKAGE_PREFIX}-fftw"
         "${MINGW_PACKAGE_PREFIX}-gdcm"
         "${MINGW_PACKAGE_PREFIX}-hdf5"
         "${MINGW_PACKAGE_PREFIX}-libjpeg"
         "${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-libtiff"
         #"${MINGW_PACKAGE_PREFIX}-opencl-icd"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "${MINGW_PACKAGE_PREFIX}-gtest"
             "${MINGW_PACKAGE_PREFIX}-opencv"
             "${MINGW_PACKAGE_PREFIX}-vtk"
             "${MINGW_PACKAGE_PREFIX}-adios2"
             $([[ ${MSYSTEM} == MINGW64 ]] || echo "${MINGW_PACKAGE_PREFIX}-anari-sdk")
             "${MINGW_PACKAGE_PREFIX}-cgns"
             "${MINGW_PACKAGE_PREFIX}-ffmpeg"
             "${MINGW_PACKAGE_PREFIX}-cli11"
             "${MINGW_PACKAGE_PREFIX}-fast_float"
             "${MINGW_PACKAGE_PREFIX}-gdal"
             "${MINGW_PACKAGE_PREFIX}-gl2ps"
             "${MINGW_PACKAGE_PREFIX}-libmariadbclient"
             "${MINGW_PACKAGE_PREFIX}-liblas"
             "${MINGW_PACKAGE_PREFIX}-libogg"
             "${MINGW_PACKAGE_PREFIX}-libtheora"
             "${MINGW_PACKAGE_PREFIX}-opencascade"
             "${MINGW_PACKAGE_PREFIX}-openslide"
             "${MINGW_PACKAGE_PREFIX}-openturns"
             "${MINGW_PACKAGE_PREFIX}-openvdb"
             "${MINGW_PACKAGE_PREFIX}-openvr"
             "${MINGW_PACKAGE_PREFIX}-pdal"
             "${MINGW_PACKAGE_PREFIX}-proj"
             "${MINGW_PACKAGE_PREFIX}-python"
             "${MINGW_PACKAGE_PREFIX}-qt6-base"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-unixodbc"
             "${MINGW_PACKAGE_PREFIX}-utf8cpp")
optdepends=("${MINGW_PACKAGE_PREFIX}-opencv: ITK-OpenCV bridge"
            "${MINGW_PACKAGE_PREFIX}-vtk: ITK-VTK bridge")
source=("https://github.com/InsightSoftwareConsortium/ITK/archive/v${pkgver}/ITK-${pkgver}.tar.gz"
        libminc-pr-129.patch)
sha256sums=('683027617442391220eb79869d71652a54c4b47517ca6ca14d4b01c2583f5a1c'
            '14c1fe4b41fa77aed8483dbece655740dd485e8d78184c9351063a5fb77fa0b4')

prepare() {
  cd "ITK-${pkgver}"
  patch -p1 -i "${srcdir}"/libminc-pr-129.patch
}

build() {
  local -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${CARCH} == x86_64 ]]; then
    _extra_config+=("-DVNL_CONFIG_ENABLE_SSE2_ROUNDING=ON")
  else
    _extra_config+=("-DVNL_CONFIG_ENABLE_SSE2_ROUNDING=OFF")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  cmake \
    -GNinja \
    -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
    -DBUILD_SHARED_LIBS=ON \
    -DBUILD_DOCUMENTATION=OFF \
    -DBUILD_EXAMPLES=OFF \
    -DBUILD_TESTING=OFF \
    -DITK_INSTALL_INCLUDE_DIR=include/ITK \
    -DITK_INSTALL_DATA_DIR=share/ITK \
    -DITK_INSTALL_DOC_DIR=share/doc/ITK \
    -DITK_INSTALL_PACKAGE_DIR=lib/cmake/ITK \
    -DITK_CUSTOM_LIBRARY_SUFFIX="" \
    -DITK_LEGACY_REMOVE=ON \
    -DITK_FUTURE_LEGACY_REMOVE=ON \
    -DITK_BUILD_DEFAULT_MODULES=OFF \
    -DITKGroup_Core=ON \
    -DITKGroup_IO=$([[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]] && echo "ON" || echo "OFF") \
    -DITKGroup_Filtering=ON \
    -DITKGroup_Registration=ON \
    -DITKGroup_Segmentation=ON \
    -DITKGroup_Numerics=ON \
    -DITKGroup_Video=ON \
    -DITKGroup_ThirdParty=ON \
    -DITKGroup_Bridge=ON \
    -DITKGroup_Nonunit=$([[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]] && echo "ON" || echo "OFF") \ \
    -DITKGroup_Compatibility=ON \
    -DModule_ITKVideoBridgeOpenCV=ON \
    -DModule_ITKVtkGlue=ON \
    -DITK_USE_GPU=OFF \
    -DUSE_FFTWD=ON \
    -DUSE_FFTWF=ON \
    -DITK_USE_SYSTEM_LIBRARIES=ON \
    -DITK_USE_SYSTEM_DCMTK=ON \
    -DITK_USE_SYSTEM_DOUBLECONVERSION=ON \
    -DITK_USE_SYSTEM_EIGEN=ON \
    -DITK_USE_SYSTEM_EXPAT=ON \
    -DITK_USE_SYSTEM_FFTW=ON \
    -DITK_USE_SYSTEM_GDCM=ON \
    -DITK_USE_SYSTEM_GOOGLETEST=ON \
    -DITK_USE_SYSTEM_HDF5=ON \
    -DITK_USE_SYSTEM_JPEG=ON \
    -DITK_USE_SYSTEM_MINC=OFF \
    -DITK_USE_SYSTEM_PNG=ON \
    -DITK_USE_SYSTEM_TIFF=ON \
    -DITK_USE_SYSTEM_VXL=OFF \
    -DITK_USE_SYSTEM_ZLIB=ON \
    -DITK_SKIP_PATH_LENGTH_CHECKS=1 \
    -DITK_FORBID_DOWNLOADS=ON \
    -DVNL_CONFIG_THREAD_SAFE=ON \
    -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python \
    "${_extra_config[@]}" \
    -S "ITK-${pkgver}" \
    -B "build-${MSYSTEM}"

  cmake --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}"

  local PREFIX_DEPS=$(cygpath -am ${MINGW_PREFIX})
  sed -s "s|${PREFIX_DEPS}|\${_IMPORT_PREFIX}|g" \
    -i "${pkgdir}${MINGW_PREFIX}/lib/cmake/${_realname}/ITKTargets-release.cmake"
  find "${pkgdir}${MINGW_PREFIX}/lib/cmake/${_realname}" -name '*.cmake' -exec \
    sed -s "s|${PREFIX_DEPS}|\${ITK_INSTALL_PREFIX}|g" -i {} \;

  install -Dm644 "ITK-${pkgver}/LICENSE" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
  install -Dm644 "ITK-${pkgver}/NOTICE" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/NOTICE"
  install -Dm644 "ITK-${pkgver}/Modules/ThirdParty/KWSys/src/KWSys/Copyright.txt" \
    "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/KWSys/Copyright.txt"
}
